/*
 *	File	: alg-exp.c
 *
 *	Title	: Demo Race Conditions.
 *
 *	Short	: Software solution for mutex
 *
 *	Long 	:
 *
 *	Author	: Paul Crocker
 *
 *	Date	 : 25 Abril de 2004 
 */

#include <pthread.h>

#include <stdio.h>
#include <stdlib.h>

#define PAUSA(A) fflush(stdin);printf("Pausa %s\n",A);getchar();
#define wait1 {float indicez1;for(indicez1=0;indicez1<500;indicez1=indicez1+1.0);}

//#define VALOR 100000
#define VALOR 10


/* variaveis partilhadas pelos threads */
float x=0;	
int vez=1;

void *funcao1 (void *args);
void *funcao2 (void *args);

int main(int argc, char* argv[])
{
	pthread_t  th1,th2;
	setbuf(stdout,NULL);

	PAUSA("Start: Iniciar press return ")
  
	pthread_create (&th1,   NULL, funcao1, NULL);
	pthread_create (&th2,   NULL, funcao2, NULL); 

	pthread_join ( th2, NULL);
	pthread_join ( th1, NULL);
	
	printf("error = %f\n",x-2.0*VALOR);
	PAUSA("Fim : press return");
	return 0;
}

void *funcao1 (void *args)
{
  int i;
  for (i=0;i<VALOR;i++)
  {
		///printf("process 1 .. %d  vez=%d\n",i,vez);
		wait1
		//busy waiting uses bickets of cpu
		while (vez == 2) ;
			x=x+1.0;
		vez = 2; 
		wait1
  }
   return (NULL);
}

void *funcao2 (void *args)
{
  int i;
  for (i=0;i<VALOR;i++)
  {
		wait1
		///printf("process 2 .. %d  vez=%d\n",i,vez);
		while (vez == 1) ;
			x=x+1.0;
		vez = 1; 
		wait1
  }
   return (NULL);
}

