/*
 *	File	: alg-exp.c
 *
 *	Title	: Demo Race Conditions.
 *
 *	Short	: Software solution for mutex .. dekker
 *
 *	Long 	:
 *
 *	Author	: Paul Crocker
 *
 *	Date	 : 25 Abril de 2004 
 */

#include <pthread.h>

#include <stdio.h>
#include <stdlib.h>

#define PAUSA(A) fflush(stdin);printf("Pausa %s\n",A);getchar();
#define waitp1 {float indicez1;for(indicez1=0;indicez1<10;indicez1=indicez1+1.0);}
#define waitp2 {float indicez1;for(indicez1=0;indicez1<50000;indicez1=indicez1+1.0);}

//#define VALOR 100000
#define VALOR 1000


/* variaveis partilhadas pelos threads */
#define VERDADE 1
#define FALSO   0
float x=0;	
int vez=1;
int P1QuerEntrar;
int P2QuerEntrar;


void *funcao1 (void *args);
void *funcao2 (void *args);

int main(int argc, char* argv[])
{
	pthread_t  th1,th2;
	//setbuf(stdout,NULL);

	PAUSA("Start: Iniciar press return ")
  
	pthread_create (&th1,   NULL, funcao1, NULL);
	pthread_create (&th2,   NULL, funcao2, NULL); 

	pthread_join ( th2, NULL);
	pthread_join ( th1, NULL);
	
	printf("error = %f\n",x-2.0*VALOR);
	PAUSA("Fim : press return");
	return 0;
}

void *funcao1 (void *args)
{
  int i;
  for (i=0;i<VALOR;i++)
  {
	
		waitp1
		
		P1QuerEntrar = VERDADE;		//P1 est pronto a entrar na SC
		while (P2QuerEntrar) ;
		if ( vez == 2 )
      {
	        P1QuerEntrar = FALSO;
	        while (vez == 2) ;	 	//testa acesso
           P1QuerEntrar = VERDADE;
	   };
	   
		//printf("process 1 .. %d  vez=%d\n",i,vez);
		x=x+1.0;   //executa seccao critica

		vez = 2; 			//autoriza acesso ao outro processo
		P1QuerEntrar = FALSO;

		while (vez == 2) ;
		waitp1;
  }
   return (NULL);
}

void *funcao2 (void *args)
{
  int i;
  for (i=0;i<VALOR;i++)
  {
		
		waitp2
		P2QuerEntrar = VERDADE;
		while (P1QuerEntrar) ;
      if (vez == 1)
      {
	        P2QuerEntrar = FALSO;
	        while (vez == 1) ;	 	//testa acesso
           P2QuerEntrar = VERDADE;
	   };
		
		
		//printf("process  2 .. %d  vez=%d\n",i,vez);
		x = x +1 ; //executa seccao critica

		vez = 1;   //autoriza acesso ao outro processo
		P2QuerEntrar = FALSO;

		waitp2
  }
   return (NULL);
}

