/*
 *	File	: ex1.c
 *
 *	Title	: Demo Race Conditions.
 *
 *	Short	: Programa para demonstrar race condition mais uma soluo
 *         com mutex lock	
 *
 *	Long 	:
 *
 *	Author	: Paul Crocker
 *
 *	Date	 : 15 September 2003 
 */

#include <pthread.h>

#include <stdio.h>
#include <stdlib.h>

#define PAUSA(A) fflush(stdin);printf("Pausa %s\n",A);getchar();
#define wait1 {float indicez1;for(indicez1=0;indicez1<500;indicez1=indicez1+1.0);}

#define Numero_de_Threads 5
#define VALOR 100000

/* variaveis partilhadas pelos threads */
float x;	
pthread_mutex_t safex;

void *funcao (void *args);

int main(int argc, char* argv[])
{
	pthread_t  ropes[Numero_de_Threads];
   int i;
	x = 0;

	PAUSA("Start: Iniciar press return ")
  
	for (i=0;i<Numero_de_Threads;i++)
		pthread_create (&ropes[i],   NULL, funcao, NULL);
	 
	for (i=0;i<Numero_de_Threads;i++)
		pthread_join (ropes[i], NULL);
	
	printf("error = %f\n",x-1.0*Numero_de_Threads*VALOR);
	PAUSA("Fim : press return");
	return 0;
}

void *funcao (void *args)
{
  int i;
  for (i=0;i<VALOR;i++)
  {
		wait1
		pthread_mutex_lock(&safex);
			x=x+1.0;
		pthread_mutex_unlock (&safex);
		wait1
  }
   return (NULL);
}

